//***************************************************************************************//
//                                   e-BOT Uno                                           //
//                                  e-BOT Sumo Sonic                                     //
//                                                                                       //
//                   This enables a bot to avoid obstacles and                           //
//                              may also solve mazes.                                    //
//                                    Codes by:                                          //
//                            e-Gizmo Mechatronix Central                                //
//                             Taft, Manila, Philippines                                 //
//                               http://goo.gl/mNcAUu                                    //
//                                   March 17,2020                                       //
//***************************************************************************************//

// INITIALIZATION:
#include "eGizmo_PBot_Uno.h"
#include <Wire.h>

eGizmo_PBot_Uno PBot;

//US-100 PIN ASSIGNMENT
#define TrigPin 15
#define EchoPin 16
float Distance;
float Point;

int FullSpeed = 200; // FULL SPEED TO BUMP THE OPPONENT
int NormalSpeed = 120;  // NORMAL SPEED
int MaxDistanceDetect = 20; // DISTANCE TO DETECT THE OPPONENT
int MinDistanceDetect = 0;

int Liner = 0;
boolean Go = false;
/**********************************************************************************/


void setup()
{
  Serial.begin(9600);
  PBot.BEGIN();

  pinMode(TrigPin,OUTPUT);
  pinMode(EchoPin,INPUT);

}

int ping()
{
  digitalWrite(TrigPin,LOW);
  delayMicroseconds(10);
  digitalWrite(TrigPin,HIGH);
  delayMicroseconds(10);
  digitalWrite(TrigPin,LOW);

  Point = pulseIn(EchoPin,HIGH);
  Distance= Point *0.034/2;
  return(Distance);
}
/**********************************************************************************/
void loop()
{ 
  float Value;
  Value = ping(); // THE Value OF ULTRASONIC
  delay(10);

  // IF LINE IS DETECTED
  if((PBot.LS3_RIGHT() == HIGH|| PBot.LS2_CENTER() == HIGH) || PBot.LS1_LEFT() == HIGH)
  {
    Liner -= 1;
  }


  // IF THERE IS NO LINE DETECTED AND THERE IS NO ENEMY
  while(Liner == 1 && Value > MaxDistanceDetect) //IF LESS THAN 20CM,SEARCH MODE.
  {
    PBot.STOP();                   
    delay(200);
    LOOKING_FOR_OPPONENT();
    delay(200);
    break;
  }
  // IF THERE IS AN ENEMY AND THERE IS NO LINE DETECTED
  while((Value < MaxDistanceDetect && Value > MinDistanceDetect) && Liner == 1) // IF GREATER THAN 20cm,ATTACK MODE!
  {
    PBot.FORWARD(FullSpeed);                  
    delay(1000);
    break;
  }
 //WHILE THERE'S AN ENEMY, ATTACK MODE AND IF LINE IS DETECTED IT WILL GO BACK.
  while((Value < MaxDistanceDetect && Value > MinDistanceDetect) && Liner == 0) 
  {
    PBot.STOP();
    delay(500);
    PBot.REVERSE(NormalSpeed);
    delay(500);
    PBot.SPINLEFT(NormalSpeed);
    break;
  }


  // Turn Around if line is detected
  if(Liner == 0)
  {
    PBot.SPINLEFT(NormalSpeed);
    delay(500);
    PBot.FORWARD(NormalSpeed); //Manuver
  }
  Liner = 1;

 PBot.SERVO(1, 90); //Servo Turns 90 degrees position after the condition was finish

}

/*---------------------------*/
// Servo and Ultrasonic Funtions
void LOOKING_FOR_OPPONENT ()
{
  int OpponentOnLeft;
  int OpponentOnCenter;
  int OpponentOnRight;

  PBot.SERVO1(10);
  delay(500);

  OpponentOnRight = ping();
  WHILE_SEARCHING_LINE_DETECTED();

  PBot.SERVO1(170);
  delay(500);

  OpponentOnLeft = ping();
  WHILE_SEARCHING_LINE_DETECTED();

   PBot.SERVO1(90);
  delay(500);

  OpponentOnCenter= ping();
  WHILE_SEARCHING_LINE_DETECTED();
  /*---------------------------*/
  if(OpponentOnRight <= MaxDistanceDetect && Liner == 1 )
  {
    PBot.STOP();  
    Go = true;
    if(OpponentOnRight <= MaxDistanceDetect && Go == true){
      PBot.SPINRIGHT(FullSpeed);
      delay(300); 
      PBot.FORWARD(FullSpeed);  
      delay(500);
      Go = false;
    }
  }
  /*---------------------------*/
  else if(OpponentOnLeft <= MaxDistanceDetect && Liner == 1)
  { 
    PBot.SPINLEFT(FullSpeed);
    delay(300);
    PBot.FORWARD(FullSpeed);                                       
    delay(500);
  }
  /*---------------------------*/
  else if(OpponentOnLeft = OpponentOnRight)
  {
    PBot.FORWARD(NormalSpeed);
    delay(200);
  }
}
//**********************************************************************************
void WHILE_SEARCHING_LINE_DETECTED(){
  if(PBot.LS3_RIGHT() == HIGH  || PBot.LS1_LEFT() == HIGH)
  {
    Liner-=1;
  }
  if(Liner == 0){
    PBot.REVERSE(NormalSpeed);
    delay(500);
    PBot.SPINLEFT(FullSpeed);
    delay(500);
    PBot.FORWARD(NormalSpeed);
    PBot.STOP();
  }
  Liner = 1;

}
//Program Ends